#!/usr/bin/env bash

cd $HOME

if [[ $1 = '' ]]
then
        echo "laita argumentiksi hakemisto, jossa kuvat"
else
    mv --backup=numbered $1'/fantasy21.webm' $1'/pandemia.webm'
    nice -17 ffmpeg -i $1'/fantasy21_%05d.png'  -an -r 15 -c:v libvpx-vp9 -b:v 1M -pass 1 -an -f null /dev/null && \
    ffmpeg -i $1'/fantasy21_%05d.png'  -an -r 15 -c:v libvpx-vp9 -b:v 1M -pass 2 -c:a libopus $1'/fantasy21.webm'
fi

# parametri '-r n' tarkoittaa, että video pyörii
# n:n kuvan sekuntivauhtia.
# Muut varmaan tykkäävät minulle
# pikkuisen liian nopeasta vauhdista.

# muut ffmpeg/webm parametrit, katso:
# https://trac.ffmpeg.org/wiki/Encode/VP9
